package pl.edu.pwszgniezno.students.io.konwerter;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

public class Program {

	Map konwertery = new HashMap();
	
	public void dodajKonwerter(Konwerter konwerter) {
		konwertery.put(konwerter.jednostka(), konwerter);
	}
	
	public void wyswietlKonwertery() {
		for (Iterator iter = konwertery.values().iterator(); iter.hasNext();) {
			Konwerter konwerter = (Konwerter) iter.next();
			System.out.println(konwerter);
		}
	}
	
	public Konwerter znajdzKonwerter(String jednostka) {
		return (Konwerter) konwertery.get(jednostka);
	}
	
	public static void main(String[] args) throws IOException {
		Program program = new Program();
		
		// inicjalizacja konwerterow
		program.dodajKonwerter(new Metr());
		program.dodajKonwerter(new Centymetr());
		program.dodajKonwerter(new Kilometr());
		program.dodajKonwerter(new Cal());
		program.dodajKonwerter(new MilaMorska());

		System.out.println("Dostpne konwertery");
		program.wyswietlKonwertery();
		
		BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));

		// wczytanie wartoci do przeliczenia na metry
		System.out.println("Podaj warto do przeliczenia na metry");
		double wartosc = Double.parseDouble(reader.readLine());		
		
		// wczytanie jednostki wejciowej
		System.out.println("Podaj jednostk wejciow");
		String jednostkaWe = reader.readLine();

		// wczytanie jednostki wyjciowej
		System.out.println("Podaj jednostk wyjciow");
		String jednostkaWy = reader.readLine();

		// wyszukanie konwertera na podstawie nazwy jednostki wejciowej
		Konwerter konwerterWe = program.znajdzKonwerter(jednostkaWe);
		Konwerter konwerterWy = program.znajdzKonwerter(jednostkaWy);
		
		System.out.println("Wynik: " + konwerterWy.konwertujZ(konwerterWe.konwertujNa(wartosc)));
	}
}
